﻿using RimWorld;
using System;
using System.Collections.Generic;

namespace GainSkillExpExt
{
    public class BookOutcomeProperties_GainSkillExpExt : BookOutcomeProperties_GainSkillExp
    {
        // 全体に適用される乗数
        public float globalExpMultiplier = 1.0f;

        // 正の乗数時に上限に加算するオフセット（4で幻が20まで上昇 20以下にクランプ
        public float positiveCapOffset = 4f;

        // 負の乗数時に下限に加算するオフセット（0以上にクランプ
        public float negativeCapOffset = 0f;

        public List<IndividualSkillMultiplier> individualSkillMultipliers = new List<IndividualSkillMultiplier>();

        [Serializable]
        public class IndividualSkillMultiplier
        {
            public SkillDef skill;
            public float multiplier = 1.0f;
        }

        public override Type DoerClass => typeof(ExtendedDoerGainSkillExp);

        public float GetMultiplierForSkill(SkillDef skill)
        {
            foreach (var ism in individualSkillMultipliers)
            {
                if (ism.skill == skill)
                    return ism.multiplier;
            }
            return globalExpMultiplier;
        }
    }
}
